#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

#define DG if(0)

#define MAXM 1050000

int M, Q;

int IN[MAXM];
int A[MAXM];
int RMQ[23][MAXM];
int log2[MAXM];

void precompute() {
  for (int i = 0; i < M; i++) {
    RMQ[0][i] = A[i];
  }
  for (int l = 1; (1<<l) <= M; l++) {
    for (int i = 0; i+(1<<l) <= M; i++) {
      RMQ[l][i] = max(RMQ[l-1][i], RMQ[l-1][i+(1<<(l-1))]);
    }
  }
}

int getrmq(int a, int b) {
  DG printf("query %d..%d je max(RMQ[%d][%d], RMQ[%d][%d])\n", a, b, log2[b-a], a, log2[b-a], b-(1<<log2[b-a]));
  return max(RMQ[log2[b-a]][a], RMQ[log2[b-a]][b-(1<<log2[b-a])]);
}

int main() {
  for (int i = 0; (1<<i) < MAXM; i++)
    log2[1<<i] = i;
  for (int i = 3; i < MAXM; i++) {
    if (log2[i] == 0) log2[i] = log2[i-1];
  }
  while(true) {
    scanf("%d%d", &M, &Q);
    if (M == 0 && Q == 0) return 0;
    map<int,int> last;
    for (int i = 0; i < M; i++) {
      scanf("%d", &IN[i]);
      A[i] = last.count(IN[i]) ? last[IN[i]] : -1;
      last[IN[i]] = i;
    }
    precompute();
    DG {
      printf("IN:\t"); for (int i = 0; i < M; i++) printf("% 4d ", IN[i]); printf("\n");
      printf("A:\t"); for (int i = 0; i < M; i++) printf("% 4d ", A[i]); printf("\n");
      for (int j = 0; j < 5; j++) {
        printf("RMQ[%d]:\t", j); for (int i = 0; i < M; i++) printf("% 4d ", RMQ[j][i]); printf("\n");
      }
    }
    for (int i = 0; i < Q; i++) {
      int a, b;
      scanf("%d%d", &a, &b);
      a--; b--;
      b++;
      int m = getrmq(a, b);
      DG printf("je to %d\n", m);
      if (m >= a) {
        printf("%d\n", IN[m]);
      }
      else {
        printf("OK\n");
      }
    }
    printf("\n");
  }
}
